/*
 *  This file is part of MONGKIE. Visit <http://www.mongkie.org/> for details.
 *  Copyright (C) 2012 Korean Bioinformation Center(KOBIC)
 * 
 *  MONGKIE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  MONGKE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 * 
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.mongkie.ui.datatable.graph.actions;

import java.awt.Image;
import kobic.prefuse.Constants;
import org.mongkie.datatable.spi.DataAction;
import org.mongkie.exporter.ExportControllerUI;
import org.mongkie.ui.datatable.graph.AbstractDataTable;
import org.mongkie.ui.datatable.graph.AbstractDataTable.AbstractModel;
import org.openide.util.ImageUtilities;
import org.openide.util.Lookup;
import org.openide.util.lookup.ServiceProvider;

/**
 *
 * @author Yeongjun Jang <yjjang@kribb.re.kr>
 */
@ServiceProvider(service = DataAction.class, position = 40)
public class ExportTable extends AbstractDataAction {

    @Override
    public UI getUI() {
        return null;
    }

    @Override
    public String getName() {
        return "Export";
    }

    @Override
    public String getDescription() {
        return "Export table to CSV file";
    }

    @Override
    public Image getIcon() {
        return ImageUtilities.loadImage("org/mongkie/ui/datatable/resources/disk-return.png", false);
    }

    @Override
    public void execute(AbstractDataTable table) {
        if (table.getDataGroup().equals(Constants.NODES)) {
            Lookup.getDefault().lookup(ExportControllerUI.class).exportNodeTable();
        } else if (table.getDataGroup().equals(Constants.EDGES)) {
            Lookup.getDefault().lookup(ExportControllerUI.class).exportEdgeTable();
        } else {
            throw new IllegalArgumentException("Unknown data group of the table :" + table.getDataGroup());
        }
    }

    @Override
    public boolean isEnabled(AbstractModel model) {
        return model.getTable().getTupleCount() > 0;
    }
}
