/*
 * This file is part of MONGKIE. Visit <http://www.mongkie.org/> for details.
 * Copyright (C) 2011 Korean Bioinformation Center(KOBIC)
 * 
 * MONGKIE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * MONGKIE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * ReportPanel.java
 *
 * Created on Jun 30, 2011, 4:14:26 PM
 */
package org.mongkie.ui.enrichment.go;

import org.mongkie.gobean.EnrichedResult;

/**
 *
 * @author Yeongjun Jang <yjjang@kribb.re.kr>
 */
public class ReportPanel extends javax.swing.JPanel {

    /** Creates new form ReportPanel */
    public ReportPanel(EnrichedResult result) {
        initComponents();

        selectedTermCountValue.setText(String.valueOf(result.getSelectedGoIds().size()));
        populationCountValue.setText(String.valueOf(result.getTotalPopCount()));
        studyCountValue.setText(String.valueOf(result.getTotalStudyCount()));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        selectedTermCountLabel = new javax.swing.JLabel();
        populationCountLabel = new javax.swing.JLabel();
        studyCountLabel = new javax.swing.JLabel();
        populationCountValue = new javax.swing.JLabel();
        selectedTermCountValue = new javax.swing.JLabel();
        studyCountValue = new javax.swing.JLabel();

        selectedTermCountLabel.setText(org.openide.util.NbBundle.getMessage(ReportPanel.class, "ReportPanel.selectedTermCountLabel.text")); // NOI18N

        populationCountLabel.setText(org.openide.util.NbBundle.getMessage(ReportPanel.class, "ReportPanel.populationCountLabel.text")); // NOI18N

        studyCountLabel.setText(org.openide.util.NbBundle.getMessage(ReportPanel.class, "ReportPanel.studyCountLabel.text")); // NOI18N

        populationCountValue.setFont(populationCountValue.getFont().deriveFont(populationCountValue.getFont().getStyle() | java.awt.Font.BOLD));
        populationCountValue.setText(org.openide.util.NbBundle.getMessage(ReportPanel.class, "ReportPanel.populationCountValue.text")); // NOI18N

        selectedTermCountValue.setFont(selectedTermCountValue.getFont().deriveFont(selectedTermCountValue.getFont().getStyle() | java.awt.Font.BOLD));
        selectedTermCountValue.setText(org.openide.util.NbBundle.getMessage(ReportPanel.class, "ReportPanel.selectedTermCountValue.text")); // NOI18N

        studyCountValue.setFont(studyCountValue.getFont().deriveFont(studyCountValue.getFont().getStyle() | java.awt.Font.BOLD));
        studyCountValue.setText(org.openide.util.NbBundle.getMessage(ReportPanel.class, "ReportPanel.studyCountValue.text")); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(populationCountLabel)
                    .addComponent(selectedTermCountLabel)
                    .addComponent(studyCountLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(studyCountValue)
                    .addComponent(selectedTermCountValue)
                    .addComponent(populationCountValue))
                .addContainerGap(62, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(selectedTermCountLabel)
                    .addComponent(selectedTermCountValue))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(populationCountLabel)
                    .addComponent(populationCountValue))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(studyCountLabel)
                    .addComponent(studyCountValue))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel populationCountLabel;
    private javax.swing.JLabel populationCountValue;
    private javax.swing.JLabel selectedTermCountLabel;
    private javax.swing.JLabel selectedTermCountValue;
    private javax.swing.JLabel studyCountLabel;
    private javax.swing.JLabel studyCountValue;
    // End of variables declaration//GEN-END:variables
}
