/*
 * This file is part of MONGKIE. Visit <http://www.mongkie.org/> for details.
 * Visit <http://www.mongkie.org> for details about MONGKIE.
 * Copyright (C) 2012 Korean Bioinformation Center (KOBIC)
 *
 * MONGKIE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MONGKIE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.mongkie.im;

import org.mongkie.im.spi.InteractionSource;
import org.mongkie.visualization.MongkieDisplay;

/**
 *
 * @author Yeongjun Jang <yjjang@kribb.re.kr>
 */
public interface SourceModel<I extends InteractionSource> {

    public I getInteractionSource();

    public MongkieDisplay getDisplay();

    public boolean isLinking();

    public boolean isLinked();

    public boolean isPartiallyLinked();

    public boolean isAnnotated();

    public boolean isExpanding();

    public String getKeyField();

    public boolean addModelListener(SourceModelListener l);

    public boolean removeModelListener(SourceModelListener l);
}
