/*
 * This file is part of MONGKIE. Visit <http://www.mongkie.org/> for details.
 * Copyright (C) 2011 Korean Bioinformation Center(KOBIC)
 * 
 * MONGKIE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * MONGKIE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.mongkie.ui.kopath.search;

import org.mongkie.ui.kopath.PathwaySearchTopComponent;

/**
 * 
 * @author Yeongjun Jang <yjjang@kribb.re.kr>
 */
public class GeneIDSearchPanel extends javax.swing.JPanel {

    /** Creates new form GeneIDSearchPanel */
    public GeneIDSearchPanel() {
        initComponents();
    }

    @Override
    public void setEnabled(boolean enabled) {
        super.setEnabled(enabled);
        searchButton.setEnabled(enabled);
    }

    @Override
    public boolean requestFocusInWindow() {
        return super.requestFocusInWindow() && geneIdInputArea.requestFocusInWindow();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        selectDbLabel = new javax.swing.JLabel();
        dbComboBox = new javax.swing.JComboBox();
        geneIdInputLabel = new javax.swing.JLabel();
        inputAreaScroll = new javax.swing.JScrollPane();
        geneIdInputArea = new javax.swing.JTextArea();
        resetButton = new javax.swing.JButton();
        searchButton = new javax.swing.JButton();
        questionButton = new javax.swing.JButton();
        gicLink = new org.jdesktop.swingx.JXHyperlink();
        exampleButton = new javax.swing.JButton();

        selectDbLabel.setText(org.openide.util.NbBundle.getMessage(GeneIDSearchPanel.class, "GeneIDSearchPanel.selectDbLabel.text")); // NOI18N

        dbComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "All Databases", "KEGG", "Reactome", "BioCarta", "NCI-Nature" }));

        geneIdInputLabel.setText(org.openide.util.NbBundle.getMessage(GeneIDSearchPanel.class, "GeneIDSearchPanel.geneIdInputLabel.text")); // NOI18N

        geneIdInputArea.setColumns(20);
        geneIdInputArea.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        geneIdInputArea.setLineWrap(true);
        geneIdInputArea.setRows(4);
        geneIdInputArea.setText(org.openide.util.NbBundle.getMessage(GeneIDSearchPanel.class, "GeneIDSearchPanel.geneIdInputArea.text")); // NOI18N
        inputAreaScroll.setViewportView(geneIdInputArea);

        resetButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/mongkie/ui/kopath/resources/reset.png"))); // NOI18N
        resetButton.setText(org.openide.util.NbBundle.getMessage(GeneIDSearchPanel.class, "GeneIDSearchPanel.resetButton.text")); // NOI18N
        resetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resetButtonActionPerformed(evt);
            }
        });

        searchButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/mongkie/ui/kopath/resources/find.png"))); // NOI18N
        searchButton.setText(org.openide.util.NbBundle.getMessage(GeneIDSearchPanel.class, "GeneIDSearchPanel.searchButton.text")); // NOI18N
        searchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchButtonActionPerformed(evt);
            }
        });

        questionButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/mongkie/ui/kopath/resources/question.png"))); // NOI18N
        questionButton.setText(org.openide.util.NbBundle.getMessage(GeneIDSearchPanel.class, "GeneIDSearchPanel.questionButton.text")); // NOI18N
        questionButton.setBorderPainted(false);
        questionButton.setContentAreaFilled(false);
        questionButton.setFocusPainted(false);
        questionButton.setMargin(new java.awt.Insets(0, -1, 0, -1));

        gicLink.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/mongkie/ui/kopath/resources/converter.png"))); // NOI18N
        gicLink.setText(org.openide.util.NbBundle.getMessage(GeneIDSearchPanel.class, "GeneIDSearchPanel.gicLink.text")); // NOI18N
        gicLink.setClickedColor(new java.awt.Color(0, 51, 255));
        gicLink.setEnabled(false);
        gicLink.setFocusPainted(false);

        exampleButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/mongkie/ui/kopath/resources/paste.png"))); // NOI18N
        exampleButton.setText(org.openide.util.NbBundle.getMessage(GeneIDSearchPanel.class, "GeneIDSearchPanel.exampleButton.text")); // NOI18N
        exampleButton.setToolTipText(org.openide.util.NbBundle.getMessage(GeneIDSearchPanel.class, "GeneIDSearchPanel.exampleButton.toolTipText")); // NOI18N
        exampleButton.setBorderPainted(false);
        exampleButton.setContentAreaFilled(false);
        exampleButton.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        exampleButton.setFocusPainted(false);
        exampleButton.setMargin(new java.awt.Insets(2, 4, 2, 4));
        exampleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exampleButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(inputAreaScroll, javax.swing.GroupLayout.DEFAULT_SIZE, 254, Short.MAX_VALUE)
                    .addComponent(dbComboBox, javax.swing.GroupLayout.Alignment.TRAILING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(resetButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(searchButton))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(selectDbLabel)
                            .addComponent(gicLink, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(questionButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(geneIdInputLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(exampleButton)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(selectDbLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(dbComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(questionButton)
                    .addComponent(geneIdInputLabel)
                    .addComponent(exampleButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(inputAreaScroll, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(gicLink, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(searchButton)
                    .addComponent(resetButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {resetButton, searchButton});

    }// </editor-fold>//GEN-END:initComponents

    private void searchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchButtonActionPerformed
        PathwaySearchTopComponent.findInstance().search(geneIdInputArea.getText(), true);
    }//GEN-LAST:event_searchButtonActionPerformed

    private void resetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_resetButtonActionPerformed
        geneIdInputArea.setText(null);
}//GEN-LAST:event_resetButtonActionPerformed

    private void exampleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exampleButtonActionPerformed
//        geneIdInputArea.setText("7124,672");
        geneIdInputArea.setText("581,672");
}//GEN-LAST:event_exampleButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox dbComboBox;
    private javax.swing.JButton exampleButton;
    private javax.swing.JTextArea geneIdInputArea;
    private javax.swing.JLabel geneIdInputLabel;
    private org.jdesktop.swingx.JXHyperlink gicLink;
    private javax.swing.JScrollPane inputAreaScroll;
    private javax.swing.JButton questionButton;
    private javax.swing.JButton resetButton;
    private javax.swing.JButton searchButton;
    private javax.swing.JLabel selectDbLabel;
    // End of variables declaration//GEN-END:variables
}
